/* Test Ad */

/*   Copyright 2018-2021 Prebid.org, Inc.

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 CHANGE NOTICE: The file content was modified to rebrand the work, adapt the product for the new use case, and change the distribution license.
 The patch to the original code is available in the TestAd repository.
 All changes after applying the patch are made under the new license and copyrights mentioned at the beginning of this file.
*/

#import <SafariServices/SafariServices.h>

#import "TADURLOpenAttempterBlock.h"
#import "TADViewControllerProvider.h"
#import "TADVoidBlock.h"
#import "TADModalManager.h"
#import "TADModalState.h"
#import "TADOpenMeasurementSession.h"

@class TestAd;
@class TADAdConfiguration;

typedef TADOpenMeasurementSession * _Nullable (^TADOpenMeasurementSessionProvider)(void);

NS_ASSUME_NONNULL_BEGIN

@interface TADSafariVCOpener: NSObject <SFSafariViewControllerDelegate>

- (instancetype)initWithSDKConfiguration:(TestAd *)sdkConfiguration
                            modalManager:(TADModalManager *)modalManager
                  viewControllerProvider:(TADViewControllerProvider)viewControllerProvider
              measurementSessionProvider:(TADOpenMeasurementSessionProvider)measurementSessionProvider
             onWillLoadURLInClickthrough:(nullable TADVoidBlock)onWillLoadURLInClickthrough
                     onWillLeaveAppBlock:(nullable TADVoidBlock)onWillLeaveAppBlock
               onClickthroughPoppedBlock:(nullable TADModalStatePopHandler)onClickthroughPoppedBlock
                      onDidLeaveAppBlock:(nullable TADModalStateAppLeavingHandler)onDidLeaveAppBlock NS_DESIGNATED_INITIALIZER;

- (instancetype)init NS_UNAVAILABLE;

- (BOOL)openURL:(NSURL *)url onClickthroughExitBlock:(nullable TADVoidBlock)onClickthroughExitBlock;

@end

NS_ASSUME_NONNULL_END
