/* Test Ad */

/*   Copyright 2018-2021 Prebid.org, Inc.

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 CHANGE NOTICE: The file content was modified to rebrand the work, adapt the product for the new use case, and change the distribution license.
 The patch to the original code is available in the TestAd repository.
 All changes after applying the patch are made under the new license and copyrights mentioned at the beginning of this file.
*/

#import "TADTrackingURLVisitorBlock.h"
#import "TADURLOpenAttempterBlock.h"

NS_ASSUME_NONNULL_BEGIN

@interface TADExternalLinkHandler: NSObject

@property (nonatomic, strong, nonnull, readonly) TADTrackingURLVisitorBlock trackingUrlVisitor;
@property (nonatomic, nonnull, readonly) TADExternalLinkHandler *asDeepLinkHandler;

- (instancetype)initWithPrimaryUrlOpener:(TADExternalURLOpenerBlock)primaryUrlOpener
                       deepLinkUrlOpener:(TADExternalURLOpenerBlock)deepLinkUrlOpener
                      trackingUrlVisitor:(TADTrackingURLVisitorBlock)trackingUrlVisitor NS_DESIGNATED_INITIALIZER;

- (instancetype)init NS_UNAVAILABLE;

- (void)openExternalUrl:(NSURL *)url
           trackingUrls:(nullable NSArray<NSString *> *)trackingUrls
             completion:(TADURLOpenResultHandlerBlock)completion
onClickthroughExitBlock:(nullable TADVoidBlock)onClickthroughExitBlock;

- (TADExternalLinkHandler *)handlerByAddingUrlOpenAttempter:(TADURLOpenAttempterBlock)urlOpenAttempter;

@end

NS_ASSUME_NONNULL_END
