/* Test Ad */

/*   Copyright 2018-2021 Prebid.org, Inc.

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 CHANGE NOTICE: The file content was modified to rebrand the work, adapt the product for the new use case, and change the distribution license.
 The patch to the original code is available in the TestAd repository.
 All changes after applying the patch are made under the new license and copyrights mentioned at the beginning of this file.
*/

#import <Foundation/Foundation.h>
#import "TADORTBBidExtSkadn.h"

@protocol TADTransactionDelegate;

@class WKWebView;
@class UIView;
@class TADModalManager;
@class TADAdConfiguration;
@class TADCreativeModel;
@class TADAbstractCreative;
@class TADAdDetails;
@class TADOpenMeasurementSession;
@class TADOpenMeasurementWrapper;
@class TADORTBBidExtSkadn;

@protocol TestAdServerConnectionProtocol;

NS_ASSUME_NONNULL_BEGIN
@interface TADTransaction: NSObject

@property (nonatomic, readonly, nonnull) TADAdConfiguration *adConfiguration; // If need to change use resetAdConfiguration
@property (nonatomic, strong) NSMutableArray<TADAbstractCreative *> *creatives;
@property (nonatomic, strong) NSArray<TADCreativeModel *> *creativeModels;
@property (nonatomic, strong, nullable) TADOpenMeasurementSession *measurementSession;
@property (nonatomic, strong) TADOpenMeasurementWrapper *measurementWrapper;

@property (nonatomic, strong, nullable) TADORTBBidExtSkadn *skadnInfo;
@property (nonatomic, strong, nullable) NSString *impURL; // bidResponse.ext.mobilesdk.events.imp
@property (nonatomic, strong, nullable) NSString *winURL; // bidResponse.ext.mobilesdk.events.win

@property (atomic, weak, nullable) id<TADTransactionDelegate> delegate;

- (instancetype)init NS_UNAVAILABLE;
- (instancetype)initWithServerConnection:(id<TestAdServerConnectionProtocol>)connection
                         adConfiguration:(TADAdConfiguration *)adConfiguration
                                  models:(NSArray<TADCreativeModel *> *)creativeModels NS_DESIGNATED_INITIALIZER;

- (void)startCreativeFactory;
- (nullable TADAdDetails *)getAdDetails;
- (nullable TADAbstractCreative *)getFirstCreative;
- (nullable TADAbstractCreative *)getCreativeAfter:(TADAbstractCreative *)creative;
- (nullable NSString*)revenueForCreativeAfter:(TADAbstractCreative *)creative;
- (void)resetAdConfiguration:(TADAdConfiguration *)adConfiguration;

@end
NS_ASSUME_NONNULL_END
